
%%
%User Input
fpgas=[3];%#,2,3,4,5,6,7,8,9,10]; %fpga numbers 
n_fpga=length(fpgas);
n_path=(1:1:32); %Number of paths (max number of paths is 32

%%
%Path to save the Results
save_path=strcat('/Users/pallabighosh/Documents/MEST/Result_MEST/histograms/'); %folder to save the output
%%Dataset
if ~exist(save_path, 'dir')
    mkdir(save_path)
end

%Analysis code loop
for i=1:n_fpga    
    fpga_no=fpgas(i);
    %Path 0H Detection
    path_0h=strcat('/Users/pallabighosh/Downloads/Spartan6LX9_data/ID', ...
        num2str(fpga_no),'/t_0h/');
    if exist(path_0h, 'dir') && ~isempty(path_0h)
        files = dir([path_0h,'*.csv']);
        name=files.name;
        t0=readmatrix(strcat(path_0h,name));
        % Create figure
        figure, %'visible','off'
        % Create axes
        axes1 = axes;
        hold(axes1,'on');
        % Create histogram
        histogram((t0./10^6),'DisplayName','Unused','NumBins',40);
        ylim([0 700])
        xlim([2 5.5])
        % Create ylabel
        ylabel('Occurances','FontWeight','bold');  
        % Create xlabel
        xlabel('RO Frequency (MHz)','FontWeight','bold'); 
        % Create title
        title(strcat('Histogram of frequencies for unused FPGA no: ', ...
            num2str(fpga_no)),'FontWeight','bold');  
        box(axes1,'on');
        hold(axes1,'off');
        % Set the remaining axes properties
        set(axes1,'FontSize',15,'FontWeight','bold');
        % Create legend
        legend1 = legend(axes1,'show');
        set(legend1,'FontSize',16);
        filename=strcat(save_path,'0h_FPGA_no',num2str(fpga_no),'.fig');
        filename2=strcat(save_path,'0h_FPGA_no',num2str(fpga_no),'.png');
        savefig(filename)
        saveas(gcf,filename2)
        hold on 
    end
    
    %Path 8H Detection
    path_8h=strcat('/Users/pallabighosh/Downloads/Spartan6LX9_data/ID', ...
        num2str(fpga_no),'/t_8hours/');
    if exist(path_8h, 'dir') && ~isempty(path_8h)
       files = dir([path_8h,'*.csv']);
       l=length(files);
       if l~=0
        name=files.name;
        t8=readmatrix(strcat(path_8h,name));
        % Create figure
        figure, %'visible','off'
        % Create axes
        axes1 = axes;
        hold(axes1,'on');
        % Create histogram
        histogram(t8./10^6,'DisplayName','8 Hours','NumBins',40);
        ylim([0 700])
        xlim([2 5.5])
        % Create ylabel
        ylabel('Occurances','FontWeight','bold');  
        % Create xlabel
        xlabel('RO Frequency (MHz)','FontWeight','bold'); 
        % Create title
        title(strcat('Histogram of frequencies for 8H used FPGA no: ', ...
            num2str(fpga_no)),...
        'FontWeight','bold');  
        box(axes1,'on');
        hold(axes1,'off');
        % Set the remaining axes properties
        set(axes1,'FontSize',15,'FontWeight','bold');
        % Create legend
        legend1 = legend(axes1,'show');
        set(legend1,'FontSize',16);
        filename=strcat(save_path,'8h_FPGA_no',num2str(fpga_no),'.fig');
        filename2=strcat(save_path,'8h_FPGA_no',num2str(fpga_no),'.png');
        savefig(filename)
        saveas(gcf,filename2)
        hold on %#
       end
    end
    
    %Path 12H Detection
    path_12h=strcat('/Users/pallabighosh/Downloads/Spartan6LX9_data/ID', ...
        num2str(fpga_no),'/t_12hours/');
    if exist(path_12h, 'dir')
       files = dir([path_12h,'*.csv']);
       l=length(files);
       if l~=0
        name=files.name;
        t12=readmatrix(strcat(path_12h,name));
        % Create figure
        figure, %'visible','off'
        % Create axes
        axes1 = axes;
        hold(axes1,'on');
        % Create histogram
        histogram(t12./10^6,'DisplayName','12 Hours','NumBins',40);
        ylim([0 700])
        xlim([2 5.5])
        % Create ylabel
        ylabel('Occurances','FontWeight','bold');  
        % Create xlabel
        xlabel('RO Frequency (MHz)','FontWeight','bold'); 
        % Create title
        title(strcat('Histogram of frequencies for 12H used FPGA no: ', ...
            num2str(fpga_no)),...
        'FontWeight','bold');  
        box(axes1,'on');
        hold(axes1,'off');
        % Set the remaining axes properties
        set(axes1,'FontSize',15,'FontWeight','bold');
        % Create legend
        legend1 = legend(axes1,'show');
        set(legend1,'FontSize',16);
        filename=strcat(save_path,'12h_FPGA_no',num2str(fpga_no),'.fig');
        filename2=strcat(save_path,'12h_FPGA_no',num2str(fpga_no),'.png');
        savefig(filename)
        saveas(gcf,filename2)
        hold on 
       end
    end
    
    %Path 16H Detection
    path_16h=strcat('/Users/pallabighosh/Downloads/Spartan6LX9_data/ID', ...
        num2str(fpga_no),'/t_16hours/');
    if exist(path_16h, 'dir') && ~isempty(path_16h)
       files = dir([path_16h,'*.csv']);
       l=length(files);
       if l~=0
        name=files.name;
        t16=readmatrix(strcat(path_16h,name));
        % Create figure
        figure, %'visible','off'
        % Create axes
        axes1 = axes;
        hold(axes1,'on');
        % Create histogram
        histogram(t16./10^6,'DisplayName','16 Hours','NumBins',40);
        ylim([0 700])
        xlim([2 5.5])
        % Create ylabel
        ylabel('Occurances','FontWeight','bold');  
        % Create xlabel
        xlabel('RO Frequency (MHz)','FontWeight','bold'); 
        % Create title
        title(strcat('Histogram of frequencies for 16H used FPGA no: ', ...
            num2str(fpga_no)),...
        'FontWeight','bold');  
        box(axes1,'on');
        hold(axes1,'off');
        % Set the remaining axes properties
        set(axes1,'FontSize',15,'FontWeight','bold');
        % Create legend
        legend1 = legend(axes1,'show');
        set(legend1,'FontSize',16);
        filename=strcat(save_path,'16h_FPGA_no',num2str(fpga_no),'.fig');
        filename2=strcat(save_path,'16h_FPGA_no',num2str(fpga_no),'.png');
        savefig(filename)
        saveas(gcf,filename2)
        hold on 
        %###################### ALL Together Histogram###############
        figure, %'visible','off'
        % Create axes
        axes1 = axes;
        hold(axes1,'on');
        % Create histogram
        histogram(t0./10^6,'DisplayName','0 Hours','NumBins',40);
        hold on
        histogram(t8./10^6,'DisplayName','8 Hours','NumBins',40);
        hold on
        histogram(t12./10^6,'DisplayName','12 Hours','NumBins',40);
        hold on
        histogram(t16./10^6,'DisplayName','16 Hours','NumBins',40);
        ylim([0 700])
        xlim([2 5.5])
        % Create ylabel
        ylabel('Occurances','FontWeight','bold');  
        % Create xlabel
        xlabel('RO Frequency (MHz)','FontWeight','bold'); 
        % Create title
        title(strcat('Histogram of frequencies FPGA no: ',num2str(fpga_no)),...
        'FontWeight','bold');  
        box(axes1,'on');
        hold(axes1,'off');
        % Set the remaining axes properties
        set(axes1,'FontSize',15,'FontWeight','bold');
        % Create legend
        legend1 = legend(axes1,'show');
        set(legend1,'FontSize',16);
        hold off
        filename=strcat(save_path,'ALL_FPGA_no',num2str(fpga_no),'.fig');
        filename2=strcat(save_path,'ALL_FPGA_no',num2str(fpga_no),'.png');
        savefig(filename)
        saveas(gcf,filename2)
        
        %###################### ALL Together Scatter Plot###############
        rng default % for reproducibility
        Y1 = tsne(t0,'Algorithm','barneshut','NumPCAComponents',30);
        L1    = cell(180, 1);
        L1(:) = {'0 Hour'};
        
        Y2 = tsne(t8,'Algorithm','barneshut','NumPCAComponents',30);
        L2    = cell(180, 1);
        L2(:) = {'8 Hour'};
        
        Y3 = tsne(t12,'Algorithm','barneshut','NumPCAComponents',30);    
        L3    = cell(180, 1);
        L3(:) = {'12 Hour'};
        
        Y4 = tsne(t16,'Algorithm','barneshut','NumPCAComponents',30);  
        L4    = cell(180, 1);
        L4(:) = {'16 Hour'};
        
        Y=[Y1;Y2;Y3;Y4];
        L=[L1;L2;L3;L4];
        size(Y)
        size(L)
        figure,
        gscatter(Y(:,1),Y(:,2),L)
        ylabel('Principal Component 1','FontWeight','bold', 'FontSize',15);  
        % Create xlabel
        xlabel('Principal Component 2','FontWeight','bold','FontSize',15); 
        % Create title
        title(strcat('Scatter Plot After Reducing Dimension: ',num2str(fpga_no)),...
        'FontWeight','bold');  
        box(axes1,'on');
        hold(axes1,'off');
        % Set the remaining axes properties
        set(axes1,'FontSize',15,'FontWeight','bold');
        filename=strcat(save_path,'Scatter_all_FPGA_no',num2str(fpga_no),'.fig');
        filename2=strcat(save_path,'Scatter_all__FPGA_no',num2str(fpga_no),'.png');
        savefig(filename)
        saveas(gcf,filename2)
       end
    end
end
clear all