clc ;clear all; close all
warning off;
%%
%Dataset
fpga_no=[2,3,4,6,7,8,9,10];
n_fpga=length(fpga_no);

%Percentage of data for training
ntrain=0.8; 

%input data folder
input_path=('/Users/pallabighosh/Downloads/Spartan6LX9_data/'); 
n_path=(1:1:32); %Number of paths (max number of paths is 32

%folder to save the output
save_path=('/Users/pallabighosh/Documents/MEST/Result_MEST/SVM/'); 
if ~exist(save_path, 'dir')
       mkdir(save_path)
end

%% Train-Test dataset Array Creation
count_used=1;
count_unused=1;
for i=1:n_fpga
    
    %##########################Path 0H############################
    path_0h=strcat(input_path,'ID',num2str(fpga_no(i)),'/t_0h/');
    if exist(path_0h, 'dir') && ~isempty(path_0h)
       files = dir([path_0h,'*.csv']);
       name=files.name;
       t0=readmatrix(strcat(path_0h,name));
       [RO,Path]=size(t0);
       for k=1:RO
        %Feature=[mean,kurtosis,skewness]
            unused_all(count_unused,:)=[mean(t0(RO,:)),kurtosis(t0(RO,:)),skewness(t0(RO,:))]; 
            %Feature=[mean]
            unusedm(count_unused,:)=[mean(t0(RO,:))];  
            %Feature=[kurtosis]
            unusedk(count_unused,:)=[kurtosis(t0(RO,:))];
            %Feature=[skewness]
            unuseds(count_unused,:)=[skewness(t0(RO,:))];
            %Feature=[mean,kurtosis]
            unusedmk(count_unused,:)=[mean(t0(RO,:)),kurtosis(t0(RO,:))]; 
            %Feature=[kurtosis,skewness]
            unusedks(count_unused,:)=[kurtosis(t0(RO,:)),skewness(t0(RO,:))]; 
            %Feature=[mean,skewness]
            unusedms(count_unused,:)=[mean(t0(RO,:)),skewness(t0(RO,:))];
        count_unused=count_unused+1;
       end
    end
    
    %##########################Path 8H##################################
    path_8h=strcat(input_path,'ID',num2str(fpga_no(i)),'/t_8hours/');
    if exist(path_8h, 'dir') && ~isempty(path_8h)
       files = dir([path_8h,'*.csv']);
       l=length(files);
       if l~=0
        name=files.name;
        t8=readmatrix(strcat(path_8h,name));
        [RO,Path]=size(t8);
        for k=1:RO
            %Feature=[mean,kurtosis,skewness]
            used_all(count_used,:)=[mean(t8(RO,:)),kurtosis(t8(RO,:)),skewness(t8(RO,:))]; 
            %Feature=[mean]
            usedm(count_used,:)=[mean(t8(RO,:))];  
            %Feature=[kurtosis]
            usedk(count_used,:)=[kurtosis(t8(RO,:))];
            %Feature=[skewness]
            useds(count_used,:)=[skewness(t8(RO,:))];
            %Feature=[mean,kurtosis]
            usedmk(count_used,:)=[mean(t8(RO,:)),kurtosis(t8(RO,:))]; 
            %Feature=[kurtosis,skewness]
            usedks(count_used,:)=[kurtosis(t8(RO,:)),skewness(t8(RO,:))]; 
            %Feature=[mean,skewness]
            usedms(count_used,:)=[mean(t8(RO,:)),skewness(t8(RO,:))]; 
            count_used=count_used+1;
        end
       end
    end

    %##############################Path 12H############################
    path_12h=strcat(input_path,'ID',num2str(fpga_no(i)),'/t_12hours/');
    if exist(path_12h, 'dir')
       files = dir([path_12h,'*.csv']);
       l=length(files);
       if l~=0
        name=files.name;
        t12=readmatrix(strcat(path_12h,name));
        [RO,Path]=size(t12);
        for k=1:RO
            %Feature=[mean,kurtosis,skewness]
            used_all(count_used,:)=[mean(t12(RO,:)),kurtosis(t12(RO,:)),skewness(t12(RO,:))]; 
            %Feature=[mean]
            usedm(count_used,:)=[mean(t12(RO,:))];  
            %Feature=[kurtosis]
            usedk(count_used,:)=[kurtosis(t12(RO,:))];
            %Feature=[skewness]
            useds(count_used,:)=[skewness(t12(RO,:))];
            %Feature=[mean,kurtosis]
            usedmk(count_used,:)=[mean(t12(RO,:)),kurtosis(t12(RO,:))]; 
            %Feature=[kurtosis,skewness]
            usedks(count_used,:)=[kurtosis(t12(RO,:)),skewness(t12(RO,:))]; 
            %Feature=[mean,skewness]
            usedms(count_used,:)=[mean(t12(RO,:)),skewness(t12(RO,:))];
            count_used=count_used+1;
        end
       end
    end
    
    %###############################Path 16H##########################
    path_16h=strcat(input_path,'ID',num2str(fpga_no(i)),'/t_16hours/');
    if exist(path_16h, 'dir') && ~isempty(path_16h)
       files = dir([path_16h,'*.csv']);
       l=length(files);
       if l~=0
        name=files.name;
        t16=readmatrix(strcat(path_16h,name));
        [RO,Path]=size(t16);
        for k=1:RO
            %Feature=[mean,kurtosis,skewness]
            used_all(count_used,:)=[mean(t16(RO,:)),kurtosis(t16(RO,:)),skewness(t16(RO,:))]; 
            %Feature=[mean]
            usedm(count_used,:)=[mean(t16(RO,:))];  
            %Feature=[kurtosis]
            usedk(count_used,:)=[kurtosis(t16(RO,:))];
            %Feature=[skewness]
            useds(count_used,:)=[skewness(t16(RO,:))];
            %Feature=[mean,kurtosis]
            usedmk(count_used,:)=[mean(t16(RO,:)),kurtosis(t16(RO,:))]; 
            %Feature=[kurtosis,skewness]
            usedks(count_used,:)=[kurtosis(t16(RO,:)),skewness(t16(RO,:))]; 
            %Feature=[mean,skewness]
            usedms(count_used,:)=[mean(t16(RO,:)),skewness(t16(RO,:))];
            count_used=count_used+1;
        end
       end
    end
end

count_unused=count_unused-1;
count_used=count_used-1;

%% ROC plots for each case
head=["MKS", "M" ,"K", "S", "MK", "KS", "MS"];
unused_cases=struct('unused_all',unused_all,'unusedm',unusedm,'unusedk',unusedk,'unuseds',unuseds,'unusedmk',unusedmk,'unusedks',unusedks,'unusedms',unusedms);
used_cases=struct('used_all',used_all,'usedm',usedm,'usedk',usedk,'useds',useds,'usedmk',usedmk,'usedks',usedks,'usedms',usedms);

fn_used = fieldnames(used_cases);
fn_unused=fieldnames(unused_cases);
for k=1:numel(fn_unused)
    display(k)
    clearvars -except k used_cases unused_cases fn_used fn_unused fpga_no ...
        n_fpga ntrain save_path unused_all unusedm unusedk unuseds unusedmk ...
        unusedks unusedms used_all usedm usedk useds usedmk usedks usedms ...
        count_used count_unused head
    
    if( isnumeric(used_cases.(fn_used{k})))
        unused=unused_cases.(fn_unused{k});
        used=used_cases.(fn_used{k});
        theclass(1:count_unused)=0;
        RO_data(1:count_unused,:) = unused(1:count_unused,:);
        
        theclass(count_unused+1:count_unused+count_used)=1;
        RO_data(count_unused+1:count_unused+count_used,:) = used(1:count_used,:);
        
        % draw random samples without replacement
        idx_limit=round(ntrain*length(theclass));
        index = randsample(1:length(theclass),idx_limit);
        
        trainclass(1:idx_limit)=theclass(index);
        RO_train(1:idx_limit,:)=RO_data(index,:);
        
        disp('Training Started..');
        SVM_train = fitcsvm(RO_train,trainclass,'Standardize',true, ...
            'KernelFunction','rbf','KernelScale','auto');
        disp('Training Finised!!');
         
        disp('Prediction Started..');
        ntest=(length(theclass)-idx_limit);
        all_index=(1:length(RO_data));
        index_test=setdiff(all_index,index);
        RO_test=RO_data(index_test,:);
        [label,score] = predict(SVM_train,RO_test); 
        disp('Prediction Done!!');
        
        trueclass1(1:ntest)= theclass(index_test);
        
        %AUC plot
        figure;
        [Xsvm1,Ysvm1,Tsvm,AUCsvm] = perfcurve(trueclass1',score(:,2),1);         %as used in original code, modified for Kmeans
        disp(AUCsvm);
        plot(Xsvm1,Ysvm1,LineWidth=3)
        % Create title
        title(strcat('ROC Curve for features: ',head(k)),'FontWeight', ...
            'bold','FontSize',16);
        axis square; %axis tight;
        xlabel('False positive rate','FontWeight','bold','FontSize',16); 
        ylabel('True positive rate','FontWeight','bold','FontSize',16);
        filename=strcat(save_path,'ROC_Features_',head(k),'.fig');
        filename2=strcat(save_path,'ROC_Features_',head(k),'.png');
        savefig(filename)
        saveas(gcf,filename2)

        hold off;

    end
end
clear all