%Dataset
fpga_no=[3];%#2,3,4,5,6,7,8,9,10];%(1:1:32); %fpga numbers 
n_fpga=length(fpga_no);
n_path=(1:1:32); %Number of paths (max number of paths is 32)
input_path=('/Users/pallabighosh/Downloads/Spartan6LX9_data/'); %input data folder
save_path=('/Users/pallabighosh/Documents/MEST/Result_MEST/kmeans/'); %folder to save the output
if ~exist(save_path, 'dir')
       mkdir(save_path)
end

%%
%##########################################################################
% %%Provide the mean cluster in the 
% for i=1:n_fpga
%     
%     %Path 0H
%     path_0h=strcat(input_path,'ID',num2str(fpga_no(i)),'/t_0h/');
%     if exist(path_0h, 'dir') && ~isempty(path_0h)
%        files = dir([path_0h,'*.csv']);
%        name=files.name;
%        t0=readmatrix(strcat(path_0h,name));
%        [label,cluster]=k_means(t0,24); %average for the real
%        real_clust=real_clust+cluster;
%     end
% end
% avg_real_cluster=int8(real_clust/n_fpga) %Original thres in prev code=3. This value can be considered as one TNC
% display(strcat('Threshold: Taking average of the clusters from real data: ',num2str(avg_real_cluster)))
%
%(i)Calculate predicted number of clusters(same as score), (ii)predicted label based on average
%number of predicted clusters in real data, (iii)actual label-> i+iii used
%for plotting ROC curve
%pred_cluster=ANC
%###############################################################################################################
count=1;
for i=1:n_fpga
    %%
    %Path 0H
    path_0h=strcat(input_path,'ID',num2str(fpga_no(i)),'/t_0h/');
    if exist(path_0h, 'dir') && ~isempty(path_0h)
       files = dir([path_0h,'*.csv']);
       l=length(files);
       if l~=0
        name=files.name;
        t0=readmatrix(strcat(path_0h,name));
        [pred_cluster(count)]=k_means(t0); 
        Y1 = tsne(t0,'Algorithm','barneshut','NumPCAComponents',30);        
        [cidx1,~] = kmeans(Y1,pred_cluster(count),'MaxIter',100, ...
             'EmptyAction','drop'); 
        L1=cidx1;
        figure,
        gscatter(Y1(:,1),Y1(:,2),L1)
        ylabel('Principal Component 1','FontWeight','bold', 'FontSize',15);  
        % Create xlabel
        xlabel('Principal Component 2','FontWeight','bold','FontSize',15); 
        % Create title
        title(strcat(['Scatter Plot After Reducing Dimension for ' ...
            'unused (0 Hour) RO frequencies of FPGA : '], ...
            num2str(fpga_no)),'FontWeight','bold');  
        filename=strcat(save_path,'scatter_plot_0Hours.fig');
        filename2=strcat(save_path,'scatter_plot_0Hours.fig');
        savefig(filename)
        saveas(gcf,filename2)

        actual_label(count)=1;
        count=count+1;
       end
    end
%%
    %Path 8H
    path_8h=strcat(input_path,'ID',num2str(fpga_no(i)),'/t_8hours/');
    if exist(path_8h, 'dir') && ~isempty(path_8h)
       files = dir([path_8h,'*.csv']);
       l=length(files);
       if l~=0
        name=files.name;
        t8=readmatrix(strcat(path_8h,name));
        [pred_cluster(count)]=k_means(t8);%,avg_real_cluster);
        %################Scatter Plot of the 8 Hour Data Points########
        Y2 = tsne(t8,'Algorithm','barneshut','NumPCAComponents',30);        
        [cidx1,~] = kmeans(Y2,pred_cluster(count),'MaxIter',100, ...
             'EmptyAction','drop'); 
        L2=cidx1;
        figure,
        gscatter(Y2(:,1),Y2(:,2),L2)
        ylabel('Principal Component 1','FontWeight','bold', 'FontSize',15);  
        % Create xlabel
        xlabel('Principal Component 2','FontWeight','bold','FontSize',15); 
        % Create title
        title(strcat(['Scatter Plot After Reducing Dimension for used ' ...
            '(8 Hours) RO frequencies of FPGA : '],num2str(fpga_no)), ...
            'FontWeight','bold'); 
        filename=strcat(save_path,'scatter_plot_8Hours.fig');
        filename2=strcat(save_path,'scatter_plot_8Hours.fig');
        savefig(filename)
        saveas(gcf,filename2)

        actual_label(count)=0;
        count=count+1;
       end
    end
%%
    %Path 12H
    path_12h=strcat(input_path,'ID',num2str(fpga_no(i)),'/t_12hours/');
    if exist(path_12h, 'dir')
       files = dir([path_12h,'*.csv']);
       l=length(files);
       if l~=0
        name=files.name;
        t12=readmatrix(strcat(path_12h,name));
        [pred_cluster(count)]=k_means(t12);
        %################Scatter Plot of the 12 Hours Data Points########
        Y3 = tsne(t12,'Algorithm','barneshut','NumPCAComponents',30);     
        [cidx1,~] = kmeans(Y3,pred_cluster(count),'MaxIter',100, ...
             'EmptyAction','drop'); 
        L3=cidx1;
        figure,
        gscatter(Y3(:,1),Y3(:,2),L3)
        ylabel('Principal Component 1','FontWeight','bold', 'FontSize',15);  
        % Create xlabel
        xlabel('Principal Component 2','FontWeight','bold','FontSize',15); 
        % Create title
        title(strcat('Scatter Plot After Reducing Dimension for unused (12 Hours) RO frequencies of FPGA : ',num2str(fpga_no)),...
        'FontWeight','bold');  
        filename=strcat(save_path,'scatter_plot_12Hours.fig');
        filename2=strcat(save_path,'scatter_plot_12Hours.fig');
        savefig(filename)
        saveas(gcf,filename2)
        actual_label(count)=0;
        count=count+1;
       end
    end
%%    
    %Path 16H
    path_16h=strcat(input_path,'ID',num2str(fpga_no(i)),'/t_16hours/');
    if exist(path_16h, 'dir') && ~isempty(path_16h)
       files = dir([path_16h,'*.csv']);
       l=length(files);
       if l~=0
        name=files.name;
        t16=readmatrix(strcat(path_16h,name));
        [pred_cluster(count)]=k_means(t16);

        %################Scatter Plot of the 16 Hours Data Points########
        Y4 = tsne(t16,'Algorithm','barneshut','NumPCAComponents',30);        
        [cidx1,~] = kmeans(Y4,pred_cluster(count),'MaxIter',100, ...
             'EmptyAction','drop'); 
        L4=cidx1;
        figure,
        gscatter(Y4(:,1),Y4(:,2),L4)
        ylabel('Principal Component 1','FontWeight','bold', 'FontSize',15);  
        % Create xlabel
        xlabel('Principal Component 2','FontWeight','bold','FontSize',15); 
        % Create title
        title(strcat('Scatter Plot After Reducing Dimension for unused (16 Hours) RO frequencies of FPGA : ',num2str(fpga_no)),...
        'FontWeight','bold');  
        filename=strcat(save_path,'scatter_plot_16Hours.fig');
        filename2=strcat(save_path,'scatter_plot_16Hours.fig');
        savefig(filename)
        saveas(gcf,filename2)
        actual_label(count)=0;
        count=count+1;
       end
    end
 end
 

%% #######################ROC Plots#####################################
%Plot ROC curve
rocTable.pred=pred_cluster(:);
rocTable.label=actual_label(:);
meanthresh=3:1:32;
for a = 1:length(meanthresh)  %% the for loop makes it to where the threshold is automatically altered and you do not have to do it manually
    
    positive_a = meanthresh(a) < (rocTable.pred);  % declaring an algorithm to determine if the value is greater than the threshold
    true = rocTable.label == 1; %true = if the data in the column is equal to (==) 1
    false = rocTable.label == 0; %false = if the data in the column is equal to (==) 0

    TP = sum(positive_a(true));  %true positive = if both the true statement (true) and the positive statement (positive_a) are met, then sum all the true values
    FP = sum(positive_a(false));  %false positive = if both the false statement (false) and the positive statement (positive_a) are met, then sum all the false values
    FN = sum(true) - TP; %false negative = sum of all true values minus the true positives
    TN = sum(false) - FP; %true negative = sum of all false values minus the false positives 
    
    sensitivity_a(a) = (TP/(TP+FN)); %%sensitivity equation
    specificity_a(a) = (TN/(TN+FP)); %%specificity equation
    
end 


% figure,
% axes1 = axes;
% plot(1-specificity_a, sensitivity_a,'LineWidth', 3); %%this is the standard deviation plot
% xlabel('False Positive Rate','FontSize',20,'FontWeight','bold');   %%label on x axis
% ylabel('True Positive Rate','FontSize',20,'FontWeight','bold'); 
% title('ROC Curve for Aged FPGA Detection',...
%     'FontWeight','bold','FontSize',16);
% set(axes1,'FontSize',15,'FontWeight','bold');
% filename=strcat(save_path,'ROC_FPGA_detection_all_sil_16.fig');
% filename2=strcat(save_path,'ROC_FPGA_detection_all_sil_16.png');
% savefig(filename)
% saveas(gcf,filename2)

clear all